(* generated by Ott 0.10.16 ***locally nameless*** from: lang-def.ott lang-decl.ott lang-eval.ott *)

Require Import Metatheory.

(** syntax *)
Definition expvar := var.
Definition contmvar := atom.
Definition contpvar := atom.
Definition judgmentvar := nat.
Definition index := nat.

Inductive pe : Set := 
 | pe_Empty : pe
 | pe_Cons : peb -> pe -> pe
with peb : Set := 
 | peb_Branch : contmvar -> exp -> peb
with exp : Set := 
 | e_Var_b : nat -> exp
 | e_Var_f : expvar -> exp
 | e_Con : contmvar -> exp -> exp
 | e_Lam : exp -> exp
 | e_App : exp -> exp -> exp
 | e_Case : exp -> pe -> exp
 | e_Fix : exp -> exp
 | e_Sie : exp -> exp -> exp
 | e_Proj1 : exp -> exp
 | e_Proj2 : exp -> exp
 | e_unit : exp.

Inductive pt : Set := 
 | pt_empty : pt
 | pt_cons : ptt -> pt -> pt
with ptt : Set := 
 | ptt_pattern : contmvar -> type -> ptt
with type : Set := 
 | t_Con : contpvar -> type
 | t_Unit : type
 | t_Pi : type -> type -> type
 | t_Sigma : type -> type -> type
 | t_App : type -> exp -> type
 | t_Case : exp -> contpvar -> exp -> pt -> type.

Inductive kind : Set := 
 | k_type : kind
 | k_pi : type -> kind -> kind.

Inductive bind : Set := 
 | bind_t : type -> bind
 | bind_k : kind -> bind.

Definition ectx : Set := ( list ( exp * exp ) ).

Definition Sigma : Set := list (asn bind nat).

Definition ctx : Set := ( list (AssumeList.asn type ( exp * exp )) ).

Inductive Cs : Set := 
 | Cs_Empty : Cs
 | Cs_Cons : contmvar -> Cs -> Cs.

(* EXPERIMENTAL *)

(** subrules *)
Fixpoint is_v_of_exp (e_5:exp) : Prop :=
  match e_5 with
  | (e_Var_b nat) => False
  | (e_Var_f x) => False
  | (e_Con C e) => ((is_v_of_exp e))
  | (e_Lam e) => (True)
  | (e_App e1 e2) => False
  | (e_Case e pe5) => False
  | (e_Fix e) => ((is_v_of_exp e))
  | (e_Sie e1 e2) => ((is_v_of_exp e1) /\ (is_v_of_exp e2))
  | (e_Proj1 e) => False
  | (e_Proj2 e) => False
  | e_unit => (True)
end.


(** opening up abstractions *)
Fixpoint open_pe_wrt_exp_rec (k:nat) (e5:exp) (pe_6:pe) {struct pe_6}: pe :=
  match pe_6 with
  | pe_Empty => pe_Empty 
  | (pe_Cons peb5 pe5) => pe_Cons (open_peb_wrt_exp_rec k e5 peb5) (open_pe_wrt_exp_rec k e5 pe5)
end
with open_peb_wrt_exp_rec (k:nat) (e5:exp) (peb5:peb) : peb :=
  match peb5 with
  | (peb_Branch C e) => peb_Branch C (open_exp_wrt_exp_rec (S k) e5 e)
end
with open_exp_wrt_exp_rec (k:nat) (e_5:exp) (e__6:exp) {struct e__6}: exp :=
  match e__6 with
  | (e_Var_b nat) => 
      match lt_eq_lt_dec nat k with
        | inleft (left _) => e_Var_b nat
        | inleft (right _) => e_5
        | inright _ => e_Var_b (nat - 1)
      end
  | (e_Var_f x) => e_Var_f x
  | (e_Con C e) => e_Con C (open_exp_wrt_exp_rec k e_5 e)
  | (e_Lam e) => e_Lam (open_exp_wrt_exp_rec (S k) e_5 e)
  | (e_App e1 e2) => e_App (open_exp_wrt_exp_rec k e_5 e1) (open_exp_wrt_exp_rec k e_5 e2)
  | (e_Case e pe5) => e_Case (open_exp_wrt_exp_rec k e_5 e) (open_pe_wrt_exp_rec k e_5 pe5)
  | (e_Fix e) => e_Fix (open_exp_wrt_exp_rec (S k) e_5 e)
  | (e_Sie e1 e2) => e_Sie (open_exp_wrt_exp_rec k e_5 e1) (open_exp_wrt_exp_rec k e_5 e2)
  | (e_Proj1 e) => e_Proj1 (open_exp_wrt_exp_rec k e_5 e)
  | (e_Proj2 e) => e_Proj2 (open_exp_wrt_exp_rec k e_5 e)
  | e_unit => e_unit 
end.

Fixpoint open_pt_wrt_exp_rec (k:nat) (e5:exp) (pt_6:pt) {struct pt_6}: pt :=
  match pt_6 with
  | pt_empty => pt_empty 
  | (pt_cons ptt5 pt5) => pt_cons (open_ptt_wrt_exp_rec k e5 ptt5) (open_pt_wrt_exp_rec k e5 pt5)
end
with open_ptt_wrt_exp_rec (k:nat) (e5:exp) (ptt5:ptt) : ptt :=
  match ptt5 with
  | (ptt_pattern C t) => ptt_pattern C (open_type_wrt_exp_rec (S k) e5 t)
end
with open_type_wrt_exp_rec (k:nat) (e5:exp) (t5:type) {struct t5}: type :=
  match t5 with
  | (t_Con T) => t_Con T
  | t_Unit => t_Unit 
  | (t_Pi t t') => t_Pi (open_type_wrt_exp_rec k e5 t) (open_type_wrt_exp_rec (S k) e5 t')
  | (t_Sigma t t') => t_Sigma (open_type_wrt_exp_rec k e5 t) (open_type_wrt_exp_rec (S k) e5 t')
  | (t_App t e) => t_App (open_type_wrt_exp_rec k e5 t) (open_exp_wrt_exp_rec k e5 e)
  | (t_Case e T u pt5) => t_Case (open_exp_wrt_exp_rec k e5 e) T (open_exp_wrt_exp_rec k e5 u) (open_pt_wrt_exp_rec k e5 pt5)
end.

Fixpoint open_kind_wrt_exp_rec (k:nat) (e5:exp) (k_5:kind) {struct k_5}: kind :=
  match k_5 with
  | k_type => k_type 
  | (k_pi t k1) => k_pi (open_type_wrt_exp_rec k e5 t) (open_kind_wrt_exp_rec (S k) e5 k1)
end.

Definition open_bind_wrt_exp_rec (k:nat) (e5:exp) (bind5:bind) : bind :=
  match bind5 with
  | (bind_t t) => bind_t (open_type_wrt_exp_rec k e5 t)
  | (bind_k k1) => bind_k (open_kind_wrt_exp_rec k e5 k1)
end.

Definition open_exp_wrt_exp e_5 e__6 := open_exp_wrt_exp_rec 0 e__6 e_5.

Definition open_peb_wrt_exp e5 peb5 := open_peb_wrt_exp_rec 0 peb5 e5.

Definition open_pe_wrt_exp e5 pe_6 := open_pe_wrt_exp_rec 0 pe_6 e5.

Definition open_type_wrt_exp e5 t5 := open_type_wrt_exp_rec 0 t5 e5.

Definition open_ptt_wrt_exp e5 ptt5 := open_ptt_wrt_exp_rec 0 ptt5 e5.

Definition open_pt_wrt_exp e5 pt_6 := open_pt_wrt_exp_rec 0 pt_6 e5.

Definition open_kind_wrt_exp e5 k_5 := open_kind_wrt_exp_rec 0 k_5 e5.

Definition open_bind_wrt_exp e5 bind5 := open_bind_wrt_exp_rec 0 bind5 e5.


(** terms are locally-closed pre-terms *)
(** definitions *)

(* defns LC_pe_peb_exp *)
Inductive lc_pe : pe -> Prop :=    (* defn lc_pe *)
 | lc_pe_Empty : 
     (lc_pe pe_Empty)
 | lc_pe_Cons : forall (peb5:peb) (pe5:pe),
     (lc_peb peb5) ->
     (lc_pe pe5) ->
     (lc_pe (pe_Cons peb5 pe5))
with lc_peb : peb -> Prop :=    (* defn lc_peb *)
 | lc_peb_Branch : forall (C:contmvar) (e:exp),
      ( forall x , lc_exp  ( open_exp_wrt_exp e (e_Var_f x) )  )  ->
     (lc_peb (peb_Branch C e))
with lc_exp : exp -> Prop :=    (* defn lc_exp *)
 | lc_e_Var_f : forall (x:expvar),
     (lc_exp (e_Var_f x))
 | lc_e_Con : forall (C:contmvar) (e:exp),
     (lc_exp e) ->
     (lc_exp (e_Con C e))
 | lc_e_Lam : forall (e:exp),
      ( forall x , lc_exp  ( open_exp_wrt_exp e (e_Var_f x) )  )  ->
     (lc_exp (e_Lam e))
 | lc_e_App : forall (e1 e2:exp),
     (lc_exp e1) ->
     (lc_exp e2) ->
     (lc_exp (e_App e1 e2))
 | lc_e_Case : forall (e:exp) (pe5:pe),
     (lc_exp e) ->
     (lc_pe pe5) ->
     (lc_exp (e_Case e pe5))
 | lc_e_Fix : forall (e:exp),
      ( forall f , lc_exp  ( open_exp_wrt_exp e (e_Var_f f) )  )  ->
     (lc_exp (e_Fix e))
 | lc_e_Sie : forall (e1 e2:exp),
     (lc_exp e1) ->
     (lc_exp e2) ->
     (lc_exp (e_Sie e1 e2))
 | lc_e_Proj1 : forall (e:exp),
     (lc_exp e) ->
     (lc_exp (e_Proj1 e))
 | lc_e_Proj2 : forall (e:exp),
     (lc_exp e) ->
     (lc_exp (e_Proj2 e))
 | lc_e_unit : 
     (lc_exp e_unit).

(* defns LC_pt_ptt_type *)
Inductive lc_pt : pt -> Prop :=    (* defn lc_pt *)
 | lc_pt_empty : 
     (lc_pt pt_empty)
 | lc_pt_cons : forall (ptt5:ptt) (pt5:pt),
     (lc_ptt ptt5) ->
     (lc_pt pt5) ->
     (lc_pt (pt_cons ptt5 pt5))
with lc_ptt : ptt -> Prop :=    (* defn lc_ptt *)
 | lc_ptt_pattern : forall (C:contmvar) (t:type),
      ( forall x , lc_type  ( open_type_wrt_exp t (e_Var_f x) )  )  ->
     (lc_ptt (ptt_pattern C t))
with lc_type : type -> Prop :=    (* defn lc_type *)
 | lc_t_Con : forall (T:contpvar),
     (lc_type (t_Con T))
 | lc_t_Unit : 
     (lc_type t_Unit)
 | lc_t_Pi : forall (t t':type),
     (lc_type t) ->
      ( forall x , lc_type  ( open_type_wrt_exp t' (e_Var_f x) )  )  ->
     (lc_type (t_Pi t t'))
 | lc_t_Sigma : forall (t t':type),
     (lc_type t) ->
      ( forall x , lc_type  ( open_type_wrt_exp t' (e_Var_f x) )  )  ->
     (lc_type (t_Sigma t t'))
 | lc_t_App : forall (t:type) (e:exp),
     (lc_type t) ->
     (lc_exp e) ->
     (lc_type (t_App t e))
 | lc_t_Case : forall (e:exp) (T:contpvar) (u:exp) (pt5:pt),
     (lc_exp e) ->
     (lc_exp u) ->
     (lc_pt pt5) ->
     (lc_type (t_Case e T u pt5)).

(* defns LC_kind *)
Inductive lc_kind : kind -> Prop :=    (* defn lc_kind *)
 | lc_k_type : 
     (lc_kind k_type)
 | lc_k_pi : forall (t:type) (k1:kind),
     (lc_type t) ->
      ( forall x , lc_kind  ( open_kind_wrt_exp k1 (e_Var_f x) )  )  ->
     (lc_kind (k_pi t k1)).

(* defns LC_bind *)
Inductive lc_bind : bind -> Prop :=    (* defn lc_bind *)
 | lc_bind_t : forall (t:type),
     (lc_type t) ->
     (lc_bind (bind_t t))
 | lc_bind_k : forall (k1:kind),
     (lc_kind k1) ->
     (lc_bind (bind_k k1)).

(** free variables *)
Fixpoint efv_pe (pe_6:pe) : vars :=
  match pe_6 with
  | pe_Empty => {}
  | (pe_Cons peb5 pe5) => (efv_peb peb5) \u (efv_pe pe5)
end
with efv_peb (peb5:peb) : vars :=
  match peb5 with
  | (peb_Branch C e) => (efv_exp e)
end
with efv_exp (e_5:exp) : vars :=
  match e_5 with
  | (e_Var_b nat) => {}
  | (e_Var_f x) => {{x}}
  | (e_Con C e) => (efv_exp e)
  | (e_Lam e) => (efv_exp e)
  | (e_App e1 e2) => (efv_exp e1) \u (efv_exp e2)
  | (e_Case e pe5) => (efv_exp e) \u (efv_pe pe5)
  | (e_Fix e) => (efv_exp e)
  | (e_Sie e1 e2) => (efv_exp e1) \u (efv_exp e2)
  | (e_Proj1 e) => (efv_exp e)
  | (e_Proj2 e) => (efv_exp e)
  | e_unit => {}
end.

Fixpoint efv_pt (pt_6:pt) : vars :=
  match pt_6 with
  | pt_empty => {}
  | (pt_cons ptt5 pt5) => (efv_ptt ptt5) \u (efv_pt pt5)
end
with efv_ptt (ptt5:ptt) : vars :=
  match ptt5 with
  | (ptt_pattern C t) => (efv_type t)
end
with efv_type (t5:type) : vars :=
  match t5 with
  | (t_Con T) => {}
  | t_Unit => {}
  | (t_Pi t t') => (efv_type t) \u (efv_type t')
  | (t_Sigma t t') => (efv_type t) \u (efv_type t')
  | (t_App t e) => (efv_type t) \u (efv_exp e)
  | (t_Case e T u pt5) => (efv_exp e) \u (efv_exp u) \u (efv_pt pt5)
end.

Fixpoint efv_kind (k_5:kind) : vars :=
  match k_5 with
  | k_type => {}
  | (k_pi t k1) => (efv_type t) \u (efv_kind k1)
end.

Definition efv_bind (bind5:bind) : vars :=
  match bind5 with
  | (bind_t t) => (efv_type t)
  | (bind_k k1) => (efv_kind k1)
end.


(** substitutions *)
Fixpoint esubst_pe (e5:exp) (x5:expvar) (pe_6:pe) {struct pe_6} : pe :=
  match pe_6 with
  | pe_Empty => pe_Empty 
  | (pe_Cons peb5 pe5) => pe_Cons (esubst_peb e5 x5 peb5) (esubst_pe e5 x5 pe5)
end
with esubst_peb (e5:exp) (x5:expvar) (peb5:peb) {struct peb5} : peb :=
  match peb5 with
  | (peb_Branch C e) => peb_Branch C (esubst_exp e5 x5 e)
end
with esubst_exp (e_5:exp) (x5:expvar) (e__6:exp) {struct e__6} : exp :=
  match e__6 with
  | (e_Var_b nat) => e_Var_b nat
  | (e_Var_f x) => (if eq_var x x5 then e_5 else (e_Var_f x))
  | (e_Con C e) => e_Con C (esubst_exp e_5 x5 e)
  | (e_Lam e) => e_Lam (esubst_exp e_5 x5 e)
  | (e_App e1 e2) => e_App (esubst_exp e_5 x5 e1) (esubst_exp e_5 x5 e2)
  | (e_Case e pe5) => e_Case (esubst_exp e_5 x5 e) (esubst_pe e_5 x5 pe5)
  | (e_Fix e) => e_Fix (esubst_exp e_5 x5 e)
  | (e_Sie e1 e2) => e_Sie (esubst_exp e_5 x5 e1) (esubst_exp e_5 x5 e2)
  | (e_Proj1 e) => e_Proj1 (esubst_exp e_5 x5 e)
  | (e_Proj2 e) => e_Proj2 (esubst_exp e_5 x5 e)
  | e_unit => e_unit 
end.

Fixpoint esubst_pt (e5:exp) (x5:expvar) (pt_6:pt) {struct pt_6} : pt :=
  match pt_6 with
  | pt_empty => pt_empty 
  | (pt_cons ptt5 pt5) => pt_cons (esubst_ptt e5 x5 ptt5) (esubst_pt e5 x5 pt5)
end
with esubst_ptt (e5:exp) (x5:expvar) (ptt5:ptt) {struct ptt5} : ptt :=
  match ptt5 with
  | (ptt_pattern C t) => ptt_pattern C (esubst_type e5 x5 t)
end
with esubst_type (e5:exp) (x5:expvar) (t5:type) {struct t5} : type :=
  match t5 with
  | (t_Con T) => t_Con T
  | t_Unit => t_Unit 
  | (t_Pi t t') => t_Pi (esubst_type e5 x5 t) (esubst_type e5 x5 t')
  | (t_Sigma t t') => t_Sigma (esubst_type e5 x5 t) (esubst_type e5 x5 t')
  | (t_App t e) => t_App (esubst_type e5 x5 t) (esubst_exp e5 x5 e)
  | (t_Case e T u pt5) => t_Case (esubst_exp e5 x5 e) T (esubst_exp e5 x5 u) (esubst_pt e5 x5 pt5)
end.

Fixpoint esubst_kind (e5:exp) (x5:expvar) (k_5:kind) {struct k_5} : kind :=
  match k_5 with
  | k_type => k_type 
  | (k_pi t k1) => k_pi (esubst_type e5 x5 t) (esubst_kind e5 x5 k1)
end.

Definition esubst_bind (e5:exp) (x5:expvar) (bind5:bind) : bind :=
  match bind5 with
  | (bind_t t) => bind_t (esubst_type e5 x5 t)
  | (bind_k k1) => bind_k (esubst_kind e5 x5 k1)
end.


Parameter Signature : Sigma.

Parameter isEq  : ectx -> exp -> exp -> Prop.



(* Work around Ott bug in the Coq ln output *)

Inductive notmatching_peb : peb -> peb -> Prop :=    (* defn notmatching_pe *)
 | notmatching_peb_intro : forall (Ci:contmvar) (ei:exp) (Cj:contmvar) (ej:exp),
     lc_peb (peb_Branch Ci ei) ->
     lc_peb (peb_Branch Cj ej) ->
      Ci  <>  Cj  ->
     notmatching_peb (peb_Branch Ci ei) (peb_Branch Cj ej).

Inductive notmatching_ptt : ptt -> ptt -> Prop :=    (* defn notmatching_ptt *)
 | notmatching_ptt_intro : forall (Ci:contmvar) (ti:type) (Cj:contmvar) (tj:type),
     lc_ptt (ptt_pattern Ci ti) ->
     lc_ptt (ptt_pattern Cj tj) ->
      Ci  <>  Cj  ->
     notmatching_ptt (ptt_pattern Ci ti) (ptt_pattern Cj tj).	

Fixpoint lc_ectx (D : ectx) : Prop :=
  match D with 
    | nil => True 
    | (e1 , e2) :: D' => lc_exp e1 /\ lc_exp e2 /\ lc_ectx D' 
  end.




(** definitions *)

(* defns JPTT *)
Inductive find_pt : ptt -> pt -> Prop :=    (* defn find_pt *)
 | pt_here : forall (ptt5:ptt) (pt5:pt),
     lc_ptt ptt5 ->
     lc_pt pt5 ->
     find_pt ptt5 (pt_cons ptt5 pt5)
 | pt_there : forall (ptt5 ptt':ptt) (pt5:pt),
     find_pt ptt5 pt5 ->
      (notmatching_ptt  ptt'   ptt5 )  ->
     find_pt ptt5 (pt_cons ptt' pt5).

(* defns JPEB *)
Inductive find_pe : peb -> pe -> Prop :=    (* defn find_pe *)
 | pe_here : forall (peb5:peb) (pe5:pe),
     lc_peb peb5 ->
     lc_pe pe5 ->
     find_pe peb5 (pe_Cons peb5 pe5)
 | pe_there : forall (peb5 peb':peb) (pe5:pe),
     find_pe peb5 pe5 ->
      (notmatching_peb  peb'   peb5 )  ->
     find_pe peb5 (pe_Cons peb' pe5).

(* defns JPURE *)
Inductive pure : exp -> Prop :=    (* defn pure *)
 | pure_var : forall (x:expvar),
     pure (e_Var_f x)
 | pure_unit : 
     pure e_unit
 | pure_lam : forall (e:exp),
     lc_exp (e_Lam e) ->
     pure  (e_Lam e) 
 | pure_fun : forall (v5:exp),
     is_v_of_exp v5 ->
     lc_exp (e_Fix v5) ->
     pure  (e_Fix v5) 
 | pure_prod : forall (e1 e2:exp),
     pure e1 ->
     pure e2 ->
     pure (e_Sie e1 e2)
 | pure_con : forall (C:contmvar) (e:exp),
     pure e ->
     pure  (e_Con C e) 
 | pure_proj1 : forall (e:exp),
     pure e ->
     pure (e_Proj1 e)
 | pure_proj2 : forall (e:exp),
     pure e ->
     pure (e_Proj2 e).

(* defns JINCON *)
Inductive incon : ectx -> Prop :=    (* defn incon *)
 | incon_intro : forall (D:ectx) (e1 e2:exp) (C1 C2:contmvar),
     pure e1 ->
     pure e2 ->
      isEq  D   (e_Con C1 e1)   (e_Con C2 e2)  ->
      C1  <>  C2  ->
     incon D.

(* defns Jdtype *)
Inductive wfs : Sigma -> Prop :=    (* defn wfs *)
 | S_Empty : 
     wfs  nil 
 | S_Ctr : forall (Sigma5:Sigma) (C:contmvar) (t:type) (T:contpvar) (e:exp),
     wfs Sigma5 ->
     wft  nil   (t_Pi t (t_App (t_Con T) e))  k_type ->
     wfs  ( ( AssumeList.VarAsn nat  C    (bind_t  (t_Pi t (t_App (t_Con T) e)) )  ) ::  Sigma5  ) 
 | S_DType : forall (Sigma5:Sigma) (T:contpvar) (t1:type),
     wfs Sigma5 ->
     wfk  nil   (k_pi t1 k_type)  ->
     wfs  ( ( AssumeList.VarAsn nat  T    (bind_k  (k_pi t1 k_type) )  ) ::  Sigma5  ) 
with wfc : ctx -> Prop :=    (* defn wfc *)
 | C_Empty : 
     wfc  nil 
 | C_Term : forall (G:ctx) (x:expvar) (t:type),
     wfc G ->
      (  x  \notin dom  G  )  ->
     wft G t k_type ->
     wfc  (AssumeList.VarAsn (exp * exp)  x   t  ::  G  ) 
 | C_Eq : forall (G:ctx) (e1 e2:exp) (t:type),
     wfc G ->
     wfe G e1 t ->
     wfe G e2 t ->
     wfc  (AssumeList.AltAsn type (  e1 ,  e2  ) ::  G  ) 
with wfk : ctx -> kind -> Prop :=    (* defn wfk *)
 | WFK_Type : forall (G:ctx),
     wfc G ->
     wfk G k_type
 | WFK_Pi : forall (L:vars) (G:ctx) (t:type) (k:kind),
      ( forall x , x \notin  L  -> wfk  (AssumeList.VarAsn (exp * exp)  x   t  ::  G  )   ( open_kind_wrt_exp k (e_Var_f x) )  )  ->
     wfk G (k_pi t k)
with wft : ctx -> type -> kind -> Prop :=    (* defn wft *)
 | K_InCon : forall (G:ctx) (t:type) (k:kind),
     wfc G ->
     incon   (erase  G  )   ->
      (efv_type  t ) [<=] dom  G  ->
      lc_type  t  ->
     wfk G k ->
     wft G t k
 | K_Unit : forall (G:ctx),
     wfc G ->
     wft G t_Unit k_type
 | K_Const : forall (G:ctx) (T:contpvar) (k:kind),
     wfc G ->
      (binds  T  (bind_k  k ) Signature)  ->
     wft G (t_Con T) k
 | K_Pi : forall (L:vars) (G:ctx) (t1 t2:type),
      ( forall x , x \notin  L  -> wft  (AssumeList.VarAsn (exp * exp)  x   t1  ::  G  )   ( open_type_wrt_exp t2 (e_Var_f x) )  k_type )  ->
     wft G (t_Pi t1 t2) k_type
 | K_Sigma : forall (L:vars) (G:ctx) (t1 t2:type),
      ( forall x , x \notin  L  -> wft  (AssumeList.VarAsn (exp * exp)  x   t1  ::  G  )   ( open_type_wrt_exp t2 (e_Var_f x) )  k_type )  ->
     wft G (t_Sigma t1 t2) k_type
 | K_App : forall (L:vars) (G:ctx) (t:type) (e:exp) (k:kind) (t1:type) (k1:kind),
     wft G t (k_pi t1 k1) ->
     wfe G e t1 ->
      ( forall x , x \notin  L  -> kindeq   ( (  (e_Var_f x)  ,  e  ) ::   (erase  G  )   )    ( open_kind_wrt_exp k1 (e_Var_f x) )  k )  ->
     wfk G k ->
     wft G (t_App t e) k
 | K_Case : forall (G:ctx) (e:exp) (T:contpvar) (u:exp) (pt5:pt) (k:kind),
     wfe G e (t_App (t_Con T) u) ->
     wfpt G e u pt5 k ->
     wft G (t_Case e T u pt5) k
 | K_KConv : forall (G:ctx) (t:type) (k' k:kind),
     wft G t k ->
     kindeq  (erase  G  )  k k' ->
     wfk G k' ->
     wft G t k'
with wfpt : ctx -> exp -> exp -> pt -> kind -> Prop :=    (* defn wfpt *)
 | PK_Empty : forall (G:ctx) (e u:exp) (k:kind),
     lc_exp e ->
     lc_exp u ->
     wfk G k ->
     wfpt G e u pt_empty k
 | PK_Cons : forall (L:vars) (G:ctx) (e u:exp) (C:contmvar) (t:type) (pt5:pt) (k:kind) (s:type) (T:contpvar) (ui:exp),
     wfpt G e u pt5 k ->
      (binds  C  (bind_t   (t_Pi s (t_App (t_Con T) ui))  ) Signature)  ->
      ( forall x , x \notin  L  -> wft  (AssumeList.AltAsn type (  e ,  (e_Con C (e_Var_f x))  ) ::   (AssumeList.AltAsn type (  u ,   ( open_exp_wrt_exp ui (e_Var_f x) )   ) ::   (AssumeList.VarAsn (exp * exp)  x   s  ::  G  )   )   )   ( open_type_wrt_exp t (e_Var_f x) )  k )  ->
     wfpt G e u (pt_cons (ptt_pattern C t) pt5) k
with wfe : ctx -> exp -> type -> Prop :=    (* defn wfe *)
 | T_InCon : forall (G:ctx) (e:exp) (t:type),
     wfc G ->
     incon   (erase  G  )   ->
      (efv_exp  e ) [<=] dom  G  ->
      lc_exp  e  ->
     wft G t k_type ->
     wfe G e t
 | T_Unit : forall (G:ctx),
     wfc G ->
     wfe G e_unit t_Unit
 | T_Var : forall (G:ctx) (x:expvar) (t:type),
     wfc G ->
      (binds  x   t   G )  ->
     wfe G (e_Var_f x) t
 | T_Ctr : forall (L:vars) (G:ctx) (C:contmvar) (e:exp) (t s:type) (T:contpvar) (u:exp),
      (binds  C  (bind_t   (t_Pi s (t_App (t_Con T) u))  ) Signature)  ->
     wfe G e s ->
      ( forall x , x \notin  L  -> typeeq   ( (  (e_Var_f x)  ,  e  ) ::   (erase  G  )   )   (t_App (t_Con T)  ( open_exp_wrt_exp u (e_Var_f x) ) ) t )  ->
     wft G t k_type ->
     wfe G (e_Con C e) t
 | T_Fun : forall (L:vars) (G:ctx) (e:exp) (t1 t2:type),
      ( forall x , x \notin  L  -> wfe  (AssumeList.VarAsn (exp * exp)  x   t1  ::  G  )   ( open_exp_wrt_exp e (e_Var_f x) )   ( open_type_wrt_exp t2 (e_Var_f x) )  )  ->
     wfe G (e_Lam e)  (t_Pi t1 t2) 
 | T_App : forall (L:vars) (G:ctx) (e1 e2:exp) (t t1 t2:type),
     wfe G e1  (t_Pi t1 t2)  ->
     wfe G e2 t1 ->
      ( forall x , x \notin  L  -> typeeq   ( (  (e_Var_f x)  ,  e2  ) ::   (erase  G  )   )    ( open_type_wrt_exp t2 (e_Var_f x) )  t )  ->
     wft G t k_type ->
     wfe G (e_App e1 e2) t
 | T_Fix : forall (L:vars) (G:ctx) (e:exp) (t1 t2:type),
      ( forall f , f \notin  L  -> wfe  (AssumeList.VarAsn (exp * exp)  f   (t_Pi t1 t2)  ::  G  )   ( open_exp_wrt_exp e (e_Var_f f) )  (t_Pi t1 t2) )  ->
      ( forall f , f \notin  L  ->  (is_v_of_exp   ( open_exp_wrt_exp e (e_Var_f f) )  )  )  ->
     wfe G (e_Fix e) (t_Pi t1 t2)
 | T_Sigma : forall (L:vars) (G:ctx) (e1 e2:exp) (t1 t2 t2':type),
     wfe G e1 t1 ->
     wfe G e2 t2' ->
      ( forall x , x \notin  L  -> typeeq  ( (  (e_Var_f x)  ,  e1  ) ::   (erase  G  )   )  t2'  ( open_type_wrt_exp t2 (e_Var_f x) )  )  ->
      ( forall x , x \notin  L  -> wft  (AssumeList.VarAsn (exp * exp)  x   t1  ::  G  )   ( open_type_wrt_exp t2 (e_Var_f x) )  k_type )  ->
     wfe G (e_Sie e1 e2) (t_Sigma t1 t2)
 | T_Proj1 : forall (G:ctx) (e:exp) (t1 t2:type),
     wfe G e (t_Sigma t1 t2) ->
     wfe G (e_Proj1 e) t1
 | T_Proj2 : forall (L:vars) (G:ctx) (e:exp) (t t1 t2:type),
     wfe G e (t_Sigma t1 t2) ->
      ( forall x , x \notin  L  -> typeeq   ( (  (e_Var_f x)  ,  (e_Proj1 e)  ) ::   (erase  G  )   )    ( open_type_wrt_exp t2 (e_Var_f x) )  t )  ->
     wft G t k_type ->
     wfe G (e_Proj2 e) t
 | T_Case : forall (G:ctx) (e:exp) (pe5:pe) (t:type) (T:contpvar) (u:exp),
     wft G t k_type ->
     wfe G e (t_App (t_Con T) u) ->
      (forall  Ci   si   ui ,
                binds  Ci  (bind_t (t_Pi  si  (t_App (t_Con  T )  ui ))) Signature->
                exists  ei , find_pe (peb_Branch  Ci   ei )  pe5 )  ->
     wfpe G e u pe5 t ->
     wfe G (e_Case e pe5) t
 | T_TConv : forall (G:ctx) (e:exp) (t' t:type),
     wfe G e t ->
     typeeq  (erase  G  )  t t' ->
     wft G t' k_type ->
     wfe G e t'
with wfpe : ctx -> exp -> exp -> pe -> type -> Prop :=    (* defn wfpe *)
 | P_Done : forall (G:ctx) (e u:exp) (t:type),
     lc_exp e ->
     lc_exp u ->
     wft G t k_type ->
     wfpe G e u pe_Empty t
 | AP_Cons : forall (L:vars) (G:ctx) (e u:exp) (Ci:contmvar) (ei:exp) (pe5:pe) (t si:type) (T:contpvar) (ui:exp),
      (binds  Ci  (bind_t   (t_Pi si (t_App (t_Con T) ui))  ) Signature)  ->
      ( forall xi , xi \notin  L  -> wfe   (AssumeList.AltAsn type (  e ,  (e_Con Ci (e_Var_f xi))  ) ::   (AssumeList.AltAsn type (  u ,   ( open_exp_wrt_exp ui (e_Var_f xi) )   ) ::   (AssumeList.VarAsn (exp * exp)  xi   si  ::  G  )   )   )    ( open_exp_wrt_exp ei (e_Var_f xi) )  t )  ->
     wfpe G e u pe5 t ->
     wfpe G e u (pe_Cons (peb_Branch Ci ei) pe5) t
with ctxereq : ectx -> ectx -> Prop :=    (* defn ctxereq *)
 | CEQ_Empty : 
     ctxereq  nil   nil 
 | CEQ_Eq : forall (D:ectx) (e1 e2:exp) (D':ectx) (e1' e2':exp),
     ctxereq D D' ->
      isEq  D   e1   e1'  ->
      isEq  D   e2   e2'  ->
     ctxereq   ( (  e1  ,  e2  ) ::  D  )     ( (  e1'  ,  e2'  ) ::  D'  )  
with ctxeq : ctx -> ctx -> Prop :=    (* defn ctxeq *)
 | CQ_Empty : 
     ctxeq  nil   nil 
 | CQ_Term : forall (G:ctx) (x:expvar) (t:type) (G':ctx) (t':type),
     ctxeq G G' ->
     typeeq  (erase  G  )  t t' ->
     ctxeq  (AssumeList.VarAsn (exp * exp)  x   t  ::  G  )   (AssumeList.VarAsn (exp * exp)  x   t'  ::  G'  ) 
 | CQ_Eq : forall (G:ctx) (e1 e2:exp) (G':ctx) (e1' e2':exp),
     ctxeq G G' ->
      isEq   (erase  G  )    e1   e1'  ->
      isEq   (erase  G  )    e2   e2'  ->
     ctxeq   (AssumeList.AltAsn type (  e1 ,  e2  ) ::  G  )     (AssumeList.AltAsn type (  e1' ,  e2'  ) ::  G'  )  
with kindeq : ectx -> kind -> kind -> Prop :=    (* defn kindeq *)
 | KQ_Refl : forall (D:ectx),
      (lc_ectx D)  ->
     kindeq D k_type k_type
 | KQ_Pi : forall (L:vars) (D:ectx) (t:type) (k:kind) (t':type) (k':kind),
     typeeq D t t' ->
      ( forall x , x \notin  L  -> kindeq D  ( open_kind_wrt_exp k (e_Var_f x) )   ( open_kind_wrt_exp k' (e_Var_f x) )  )  ->
     kindeq D (k_pi t k) (k_pi t' k')
with typeeq : ectx -> type -> type -> Prop :=    (* defn typeeq *)
 | TQ_InCon : forall (D:ectx) (t t':type),
     lc_type t ->
     lc_type t' ->
     incon  D  ->
     typeeq D t t'
 | TQ_TRefl : forall (D:ectx) (T:contpvar),
      (lc_ectx D)  ->
     typeeq D (t_Con T) (t_Con T)
 | TQ_URefl : forall (D:ectx),
      (lc_ectx D)  ->
     typeeq D t_Unit t_Unit
 | TQ_Pi : forall (L:vars) (D:ectx) (t1 t2 t1' t2':type),
     typeeq D t1 t1' ->
      ( forall x , x \notin  L  -> typeeq D  ( open_type_wrt_exp t2 (e_Var_f x) )   ( open_type_wrt_exp t2' (e_Var_f x) )  )  ->
     typeeq D (t_Pi t1 t2) (t_Pi t1' t2')
 | TQ_Sigma : forall (L:vars) (D:ectx) (t1 t2 t1' t2':type),
     typeeq D t1 t1' ->
      ( forall x , x \notin  L  -> typeeq D  ( open_type_wrt_exp t2 (e_Var_f x) )   ( open_type_wrt_exp t2' (e_Var_f x) )  )  ->
     typeeq D (t_Sigma t1 t2) (t_Sigma t1' t2')
 | TQ_App : forall (D:ectx) (t:type) (e:exp) (t':type) (e':exp),
     typeeq D t t' ->
      isEq  D   e   e'  ->
     typeeq D (t_App t e) (t_App t' e')
 | TQ_Red1 : forall (L:vars) (D:ectx) (e:exp) (T:contpvar) (u:exp) (pt5:pt) (t:type) (Cj:contmvar) (w:exp) (sj:type) (uj:exp) (tj:type),
      isEq  D   e   (e_Con Cj w)  ->
     pure w ->
      (binds  Cj  (bind_t   (t_Pi sj (t_App (t_Con T) uj))  ) Signature)  ->
      ( forall xj , xj \notin  L  ->  isEq    ( (  w  ,  (e_Var_f xj)  ) ::  D  )     u    ( open_exp_wrt_exp uj (e_Var_f xj) )   )  ->
     find_pt (ptt_pattern Cj tj) pt5 ->
      ( forall xj , xj \notin  L  -> typeeq  ( (  e  ,   (e_Con Cj (e_Var_f xj))   ) ::   ( (  w  ,  (e_Var_f xj)  ) ::  D  )   )   ( open_type_wrt_exp tj (e_Var_f xj) )  t )  ->
     typeeq D (t_Case e T u pt5) t
 | TQ_Red2 : forall (L:vars) (D:ectx) (t:type) (e:exp) (T:contpvar) (u:exp) (pt5:pt) (Cj:contmvar) (w:exp) (sj:type) (uj:exp) (tj:type),
      isEq  D   e   (e_Con Cj w)  ->
     pure w ->
      (binds  Cj  (bind_t   (t_Pi sj (t_App (t_Con T) uj))  ) Signature)  ->
      ( forall xj , xj \notin  L  ->  isEq    ( (  w  ,  (e_Var_f xj)  ) ::  D  )     u    ( open_exp_wrt_exp uj (e_Var_f xj) )   )  ->
     find_pt (ptt_pattern Cj tj) pt5 ->
      ( forall xj , xj \notin  L  -> typeeq  ( (  e  ,   (e_Con Cj (e_Var_f xj))   ) ::   ( (  w  ,  (e_Var_f xj)  ) ::  D  )   )  t  ( open_type_wrt_exp tj (e_Var_f xj) )  )  ->
     typeeq D t (t_Case e T u pt5)
 | TQ_Case : forall (D:ectx) (e:exp) (T:contpvar) (u:exp) (pt5:pt) (e' u':exp) (pt':pt),
      isEq  D   e   e'  ->
      isEq  D   u   u'  ->
     pateq D e u e' u' pt5 pt' ->
     typeeq D (t_Case e T u pt5) (t_Case e' T u' pt')
with pateq : ectx -> exp -> exp -> exp -> exp -> pt -> pt -> Prop :=    (* defn pateq *)
 | TPQ_Empty : forall (D:ectx) (e u e' u':exp),
     lc_exp e ->
     lc_exp u ->
     lc_exp e' ->
     lc_exp u' ->
      (lc_ectx D)  ->
     pateq D e u e' u' pt_empty pt_empty
 | TPQ_Cons : forall (D:ectx) (e u e' u':exp) (ptt5:ptt) (pt5:pt) (ptt':ptt) (pt':pt),
     patteq D e u e' u' ptt5 ptt' ->
     pateq D e u e' u' pt5 pt' ->
     pateq D e u e' u' (pt_cons ptt5 pt5) (pt_cons ptt' pt')
with patteq : ectx -> exp -> exp -> exp -> exp -> ptt -> ptt -> Prop :=    (* defn patteq *)
 | TTPQ_Intro : forall (L:vars) (D:ectx) (e u e' u':exp) (Ci:contmvar) (ti ti' si:type) (T:contpvar) (ui:exp),
      (binds  Ci  (bind_t   (t_Pi si (t_App (t_Con T) ui))  ) Signature)  ->
      isEq  D   e   e'  ->
      isEq  D   u   u'  ->
      ( forall xi , xi \notin  L  -> typeeq  ( (  e  ,  (e_Con Ci (e_Var_f xi))  ) ::   ( (  u  ,   ( open_exp_wrt_exp ui (e_Var_f xi) )   ) ::  D  )   )   ( open_type_wrt_exp ti (e_Var_f xi) )   ( open_type_wrt_exp ti' (e_Var_f xi) )  )  ->
     patteq D e u e' u' (ptt_pattern Ci ti) (ptt_pattern Ci ti').

(* defns Jop *)
Inductive reduce : exp -> exp -> Prop :=    (* defn reduce *)
 | app_beta : forall (e12 v2:exp),
     is_v_of_exp v2 ->
     is_v_of_exp v2 ->
     lc_exp (e_Lam e12) ->
     lc_exp v2 ->
     reduce (e_App  (e_Lam e12)  v2)  (open_exp_wrt_exp  e12   v2 ) 
 | app_fun_beta : forall (v1 v2:exp),
     is_v_of_exp v1 ->
     is_v_of_exp v2 ->
     is_v_of_exp v2 ->
     lc_exp v2 ->
      (lc_exp   (e_Fix v1)  )  ->
     reduce (e_App  (e_Fix v1)  v2) (e_App   (open_exp_wrt_exp  v1   (e_Fix v1) )   v2)
 | app_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     reduce e1 e1' ->
     reduce (e_App e1 e2) (e_App e1' e2)
 | app_cong2 : forall (e2 e2' v1:exp),
     is_v_of_exp v1 ->
     is_v_of_exp v1 ->
     lc_exp v1 ->
     reduce e2 e2' ->
     reduce (e_App v1 e2) (e_App v1 e2')
 | ctr_cong : forall (C:contmvar) (e1 e1':exp),
     reduce e1 e1' ->
     reduce (e_Con C e1) (e_Con C e1')
 | pair_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     reduce e1 e1' ->
     reduce (e_Sie e1 e2) (e_Sie e1' e2)
 | pair_cong2 : forall (e2 e2' v5:exp),
     is_v_of_exp v5 ->
     is_v_of_exp v5 ->
     lc_exp v5 ->
     reduce e2 e2' ->
     reduce (e_Sie v5 e2) (e_Sie v5 e2')
 | proj_beta1 : forall (v2 v1:exp),
     is_v_of_exp v1 ->
     is_v_of_exp v2 ->
     is_v_of_exp v2 ->
     is_v_of_exp v1 ->
     lc_exp v2 ->
     lc_exp v1 ->
     reduce (e_Proj1 (e_Sie v1 v2)) v1
 | proj_beta2 : forall (v1 v2:exp),
     is_v_of_exp v1 ->
     is_v_of_exp v2 ->
     is_v_of_exp v1 ->
     is_v_of_exp v2 ->
     lc_exp v1 ->
     lc_exp v2 ->
     reduce (e_Proj2 (e_Sie v1 v2)) v2
 | proj_cong1 : forall (e e':exp),
     reduce e e' ->
     reduce (e_Proj1 e) (e_Proj1 e')
 | proj_cong2 : forall (e e':exp),
     reduce e e' ->
     reduce (e_Proj2 e) (e_Proj2 e')
 | case_cong : forall (e:exp) (pe5:pe) (e':exp),
     lc_pe pe5 ->
     reduce e e' ->
     reduce (e_Case e pe5) (e_Case e' pe5)
 | case_beta : forall (Cj:contmvar) (pe5:pe) (ej v5:exp),
     is_v_of_exp v5 ->
     is_v_of_exp v5 ->
     lc_exp v5 ->
     find_pe (peb_Branch Cj ej) pe5 ->
     reduce (e_Case (e_Con Cj v5) pe5)  (open_exp_wrt_exp  ej   v5 ) 
with mreduce : exp -> exp -> Prop :=    (* defn mreduce *)
 | refl : forall (e:exp),
     lc_exp e ->
     mreduce e e
 | step : forall (e e'' e':exp),
     reduce e e' ->
     mreduce e' e'' ->
     mreduce e e''.

(* defns Jnwop *)
Inductive nwreduce : exp -> exp -> Prop :=    (* defn nwreduce *)
 | nwreduce_app_beta : forall (e1 w2:exp),
     lc_exp (e_Lam e1) ->
     pure w2 ->
     nwreduce (e_App  (e_Lam e1)  w2)  (open_exp_wrt_exp  e1   w2 ) 
 | nwreduce_app_fun_beta : forall (v1 w2:exp),
     is_v_of_exp v1 ->
      (lc_exp   (e_Fix v1)  )  ->
     pure w2 ->
     nwreduce (e_App  (e_Fix v1)  w2) (e_App   (open_exp_wrt_exp  v1   (e_Fix v1) )   w2)
 | nwreduce_app_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     nwreduce e1 e1' ->
     nwreduce (e_App e1 e2) (e_App e1' e2)
 | nwreduce_app_cong2 : forall (e1 e2 e2':exp),
     lc_exp e1 ->
     nwreduce e2 e2' ->
     nwreduce (e_App e1 e2) (e_App e1 e2')
 | nwreduce_ctr_cong : forall (C:contmvar) (e1 e1':exp),
     nwreduce e1 e1' ->
     nwreduce (e_Con C e1) (e_Con C e1')
 | nwreduce_pair_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     nwreduce e1 e1' ->
     nwreduce (e_Sie e1 e2) (e_Sie e1' e2)
 | nwreduce_pair_cong2 : forall (e1 e2 e2':exp),
     lc_exp e1 ->
     nwreduce e2 e2' ->
     nwreduce (e_Sie e1 e2) (e_Sie e1 e2')
 | nwreduce_proj_beta1 : forall (w1 w2:exp),
     pure w1 ->
     pure w2 ->
     nwreduce (e_Proj1 (e_Sie w1 w2)) w1
 | nwreduce_proj_beta2 : forall (w1 w2:exp),
     pure w1 ->
     pure w2 ->
     nwreduce (e_Proj2 (e_Sie w1 w2)) w2
 | nwreduce_proj_cong1 : forall (e e':exp),
     nwreduce e e' ->
     nwreduce (e_Proj1 e) (e_Proj1 e')
 | nwreduce_proj_cong2 : forall (e e':exp),
     nwreduce e e' ->
     nwreduce (e_Proj2 e) (e_Proj2 e')
 | nwreduce_case_cong : forall (e:exp) (pe5:pe) (e':exp),
     lc_pe pe5 ->
     nwreduce e e' ->
     nwreduce (e_Case e pe5) (e_Case e' pe5)
 | nw_case : forall (Cj:contmvar) (w:exp) (pe5:pe) (ej:exp),
     find_pe (peb_Branch Cj ej) pe5 ->
     pure w ->
     nwreduce (e_Case (e_Con Cj w) pe5)  (open_exp_wrt_exp  ej   w ) 
with nwsteps : exp -> Prop :=    (* defn nwsteps *)
 | nwsteps_intro : forall (e e':exp),
     nwreduce e e' ->
     nwsteps e.

(* defns Jwop *)
Inductive wreduce : exp -> exp -> Prop :=    (* defn wreduce *)
 | wreduce_app_beta : forall (e1 w2:exp),
     lc_exp (e_Lam e1) ->
     pure w2 ->
      (not ( nwsteps w2 ))  ->
     wreduce (e_App  (e_Lam e1)  w2)  (open_exp_wrt_exp  e1   w2 ) 
 | wreduce_app_fun_beta : forall (v1 w2:exp),
     is_v_of_exp v1 ->
      (lc_exp   (e_Fix v1)  )  ->
     pure w2 ->
      (not ( nwsteps w2 ))  ->
     wreduce (e_App  (e_Fix v1)  w2) (e_App   (open_exp_wrt_exp  v1   (e_Fix v1) )   w2)
 | wreduce_app_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     wreduce e1 e1' ->
     wreduce (e_App e1 e2) (e_App e1' e2)
 | wreduce_app_cong2 : forall (e1 e2 e2':exp),
     wreduce e2 e2' ->
      (not ( nwsteps e1 ))  ->
      (lc_exp  e1 )  ->
     wreduce (e_App e1 e2) (e_App e1 e2')
 | wreduce_ctr_cong : forall (C:contmvar) (e1 e1':exp),
     wreduce e1 e1' ->
     wreduce (e_Con C e1) (e_Con C e1')
 | wreduce_pair_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     wreduce e1 e1' ->
     wreduce (e_Sie e1 e2) (e_Sie e1' e2)
 | wreduce_pair_cong2 : forall (e1 e2 e2':exp),
     wreduce e2 e2' ->
      (not ( nwsteps e1 ))  ->
      (lc_exp  e1 )  ->
     wreduce (e_Sie e1 e2) (e_Sie e1 e2')
 | wreduce_proj_beta1 : forall (w1 w2:exp),
     pure w1 ->
      (not ( nwsteps w1 ))  ->
     pure w2 ->
      (not ( nwsteps w2 ))  ->
     wreduce (e_Proj1 (e_Sie w1 w2)) w1
 | wreduce_proj_beta2 : forall (w1 w2:exp),
     pure w1 ->
      (not ( nwsteps w1 ))  ->
     pure w2 ->
      (not ( nwsteps w2 ))  ->
     wreduce (e_Proj2 (e_Sie w1 w2)) w2
 | wreduce_proj_cong1 : forall (e e':exp),
     wreduce e e' ->
     wreduce (e_Proj1 e) (e_Proj1 e')
 | wreduce_proj_cong2 : forall (e e':exp),
     wreduce e e' ->
     wreduce (e_Proj2 e) (e_Proj2 e')
 | wreduce_case_cong : forall (e:exp) (pe5:pe) (e':exp),
     lc_pe pe5 ->
     wreduce e e' ->
     wreduce (e_Case e pe5) (e_Case e' pe5)
 | wreduce_case_beta : forall (Cj:contmvar) (w:exp) (pe5:pe) (ej:exp),
     find_pe (peb_Branch Cj ej) pe5 ->
     pure w ->
      (not ( nwsteps w ))  ->
     wreduce (e_Case (e_Con Cj w) pe5)  (open_exp_wrt_exp  ej   w ) 
with mwreduce : exp -> exp -> Prop :=    (* defn mwreduce *)
 | mwreduce_refl : forall (e:exp),
     lc_exp e ->
     mwreduce e e
 | mwreduce_step : forall (e e'' e':exp),
     wreduce e e' ->
     mwreduce e' e'' ->
     mwreduce e e''.

(* defns Jnnop *)
Inductive nnreduce : exp -> exp -> Prop :=    (* defn nnreduce *)
 | nnreduce_app_beta : forall (e1 e2:exp),
     lc_exp (e_Lam e1) ->
     lc_exp e2 ->
     nnreduce (e_App  (e_Lam e1)  e2)  (open_exp_wrt_exp  e1   e2 ) 
 | nnreduce_app_fun_beta : forall (v1 e2:exp),
     is_v_of_exp v1 ->
     lc_exp e2 ->
      (lc_exp   (e_Fix v1)  )  ->
     nnreduce (e_App  (e_Fix v1)  e2) (e_App   (open_exp_wrt_exp  v1   (e_Fix v1) )   e2)
 | nnreduce_app_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     nnreduce e1 e1' ->
     nnreduce (e_App e1 e2) (e_App e1' e2)
 | nnreduce_app_cong2 : forall (e1 e2 e11 e2':exp),
     lc_exp e1 ->
     lc_exp e11 ->
     nnreduce e2 e2' ->
     nnreduce (e_App e1 e2) (e_App e11 e2')
 | nnreduce_ctr_cong : forall (C:contmvar) (e1 e1':exp),
     nnreduce e1 e1' ->
     nnreduce (e_Con C e1) (e_Con C e1')
 | nnreduce_pair_cong1 : forall (e1 e2 e1':exp),
     lc_exp e2 ->
     nnreduce e1 e1' ->
     nnreduce (e_Sie e1 e2) (e_Sie e1' e2)
 | nnreduce_pair_cong2 : forall (e1 e2 e2':exp),
     lc_exp e1 ->
     nnreduce e2 e2' ->
     nnreduce (e_Sie e1 e2) (e_Sie e1 e2')
 | nnreduce_proj_beta1 : forall (e1 e2:exp),
     lc_exp e2 ->
     lc_exp e1 ->
     nnreduce (e_Proj1 (e_Sie e1 e2)) e1
 | nnreduce_proj_beta2 : forall (e1 e2:exp),
     lc_exp e1 ->
     lc_exp e2 ->
     nnreduce (e_Proj2 (e_Sie e1 e2)) e2
 | nnreduce_proj_cong1 : forall (e e':exp),
     nnreduce e e' ->
     nnreduce (e_Proj1 e) (e_Proj1 e')
 | nnreduce_proj_cong2 : forall (e e':exp),
     nnreduce e e' ->
     nnreduce (e_Proj2 e) (e_Proj2 e')
 | nnreduce_case_cong : forall (e:exp) (pe5:pe) (e':exp),
     lc_pe pe5 ->
     nnreduce e e' ->
     nnreduce (e_Case e pe5) (e_Case e' pe5)
 | nnreduce_case_beta : forall (Cj:contmvar) (e:exp) (pe5:pe) (ej:exp),
     lc_exp e ->
     find_pe (peb_Branch Cj ej) pe5 ->
     nnreduce (e_Case (e_Con Cj e) pe5)  (open_exp_wrt_exp  ej   e ) .

(** infrastructure *)

(* additional definitions *)


(* instanciation of tactics *)

Ltac gather_atoms ::=
  let A := gather_atoms_with (fun x : vars => x) in
  let B := gather_atoms_with (fun x : var => {{ x }}) in
  let D1 := gather_atoms_with (fun x => efv_exp x) in
  let D2 := gather_atoms_with (fun x => efv_peb x) in
  let D3 := gather_atoms_with (fun x => efv_pe x) in
  let D4 := gather_atoms_with (fun x => efv_type x) in
  let D5 := gather_atoms_with (fun x => efv_ptt x) in
  let D6 := gather_atoms_with (fun x => efv_pt x) in
  let D7 := gather_atoms_with (fun x => efv_kind x) in
  let D8 := gather_atoms_with (fun x => efv_bind x) in
  constr:(A \u B \u D1 \u D2 \u D3 \u D4 \u D5 \u D6 \u D7 \u D8).

Hint Constructors find_pt find_pe pure incon wfs wfc wfk wft wfpt wfe wfpe ctxereq ctxeq kindeq typeeq pateq patteq reduce mreduce nwreduce nwsteps wreduce mwreduce nnreduce lc_pe lc_peb lc_exp lc_pt lc_ptt lc_type lc_kind lc_bind.




